// Copyright 2024 Brian Newman. All rights reserved.

package handlers

import (
	"database/sql"
	"net/http"
	"net/url"

	"cdmnky.io/net/patreon-ui/local.pkg/src/sitevars"

	"go.cdmnky.io/v2/net/assets"
	"go.cdmnky.io/v2/net/router"
	"go.cdmnky.io/v2/net/session"
)

// NewTemplate ...
func NewTemplate(
	db *sql.DB,
	assets *assets.Assets,
	session *session.Manager,
	sitevars *sitevars.Sitevars,
) *Template {
	return &Template{db: db, assets: assets, session: session, sitevars: sitevars}
}

// Register ...
func (x *Template) Register(r *router.Router) {
	r.Handle("POST", "/template", x.Create)
	r.Handle("GET", "/template", x.Read)
	r.Handle("PUT", "/template", x.Update)
	r.Handle("DELETE", "/template", x.Delete)
}

// Template ...
type Template struct {
	db       *sql.DB
	assets   *assets.Assets
	session  *session.Manager
	sitevars *sitevars.Sitevars
}

// Create ...
func (x *Template) Create(w http.ResponseWriter, r *http.Request, params url.Values) {
	w.Write([]byte{})
}

// Read ...
func (x *Template) Read(w http.ResponseWriter, r *http.Request, params url.Values) {
	w.Write([]byte{})
}

// Update ...
func (x *Template) Update(w http.ResponseWriter, r *http.Request, params url.Values) {
	w.Write([]byte{})
}

// Delete ...
func (x *Template) Delete(w http.ResponseWriter, r *http.Request, params url.Values) {
	w.Write([]byte{})
}
