// Copyright 2024 Brian Newman. All rights reserved.

// Package sitevars ...
package sitevars

import (
	"html/template"

	"cdmnky.io/net/patreon-ui/local.pkg/src/config"
)

// Sitevars ...
type Sitevars struct {
	Sitename  string            `json:"sitename"`
	Copyright string            `json:"copyright"`
	Port      string            `json:"port"`
	Dbfile    string            `json:"dbfile"`
	Templates []config.Template `json:"templates"`
}

// GetCopyright ...
func (x *Sitevars) GetCopyright() template.HTML {
	return template.HTML(x.Copyright)
}
