// Copyright 2024 Brian Newman. All rights reserved.
/*
	A few words about this application.
*/
package main

import (
	"fmt"
	"log"
	"os"
	"path"
	"path/filepath"

	"cdmnky.io/net/patreon-ui/handlers"
	"cdmnky.io/net/patreon-ui/local.pkg/src/config"
	"cdmnky.io/net/patreon-ui/local.pkg/src/global"
)

var (
	appname = "template"
	version = "xx.yy.zz"
	build   = "yyyy.mm.dd"

	globConfig *config.Config
)

func main() {

	// Load config.json values
	// -----------------------------------------------------------------------------
	binpath, _ := os.Executable()
	binpath = path.Dir(binpath)
	data, err := os.ReadFile(filepath.Join(binpath, global.ConfigFileName))
	if err != nil {
		log.Fatal(err)
		os.Exit(1)
	}
	globConfig = config.New()
	err = globConfig.Parse(data)
	if err != nil {
		log.Fatal(err)
		os.Exit(1)
	}
	globConfig.Appname = fmt.Sprintf("%s v%s, %s", appname, version, build)

	(handlers.NewServer(
		globConfig,
	)).Start()
}
